// File: MakeBinaryNSum.java
// Input integers (unknown number on each line) from a text file.
// Write each integer read into a binary file, open the binary file and
//      sum all values
// Here the file input is done by wrapping a DataInputStreaFileInputStream with a
// DataInputStream. This gives us the readLine method to permit
// input of the file line by line
// Also demonstrates catching an EOF exception
// Prepared by Dr. Spiegel

import java.io.*;
import java.util.*;

public class MakeBinary {

// Read a line from the input file and write the ints to the binary file.
// StringTokenizer allows each token on the line to be extracted.
//      Note that all tokens are strings and are then converted (see
//      the use of the Integer class to accomplish this)       
public static void ProcessLineToBinaryFile(String LineOfInts,
                     DataOutputStream BinaryData) throws java.io.IOException
{int Sum=0;
 StringTokenizer IntTokens=new StringTokenizer(LineOfInts);
 while (IntTokens.hasMoreTokens()) {
  BinaryData.writeInt(Integer.valueOf(IntTokens.nextToken()).intValue());
 }
}

// Read a line and 
public static void ConvertToBinary(BufferedReader Input,
                         DataOutputStream Output) throws java.io.IOException
{String Line;
 while ((Line=Input.readLine())!=null)
  ProcessLineToBinaryFile(Line,Output);
}


public static void main(String[] args) throws java.io.IOException
{// Associate the disk file with the File object
 File InputFile=new File("int.dat");
 // Now, open a stream from the input file
 BufferedReader DataInput=
                         new BufferedReader(new FileReader(InputFile));
 // Create a file object
 File BinaryFile=new File("int.bin");
 // Wrap it in a stream
 DataOutputStream BinaryOutput=
                      new DataOutputStream(new FileOutputStream(BinaryFile));
 // Read the file and process it
 ConvertToBinary(DataInput,BinaryOutput);
 DataInput.close();
 BinaryOutput.close();

 // Now, just read and sum
 DataInputStream BinaryInput=new DataInputStream(new FileInputStream(BinaryFile));
 int Sum=0;
 try {
  // Check this condition to determine EOF
  while ((Sum+=BinaryInput.readInt())!=-1);
 }
 // Check for EOF with this catch
 catch (java.io.EOFException EOF) {
  System.out.println("EOF reached");
 }
 System.out.println("Sum is:"+Sum);
}


}

